// -*-ecmascript-*-

function Log(domElement)
{
    if(!domElement)
	domElement = document.appendChild(document.createElement("div"));
    this.domElement = domElement;
}

Log.prototype.write = function (text)
{
    var now = new Date();
    var stamp = now.toLocaleString();
    // (now.getMilliseconds()/1000).toString().slice(1);
    var e = this.domElement.appendChild(document.createElement("p"));
    var l = e.appendChild(document.createElement("a"));
    e.appendChild(document.createTextNode(stamp + " " + text));
    l.onclick = function () {e.parentNode.removeChild(e)};
    l.className = "dismissLink";
    l.appendChild(document.createTextNode("dismiss"));
    return e;
}

Log.prototype.error = function (text)
{
    this.write(text).className = "error";
}
Log.prototype.warn = Log.prototype.warning = function (text)
{
    this.write(text).className = "warning";
}
Log.prototype.info = function (text)
{
//    this.write(text).className = "info";
}

Log.prototype.clear = function ()
{
    while(this.domElement.hasChildNodes())
        this.domElement.removeChild(this.domElement.firstChild);
}


// Call this like Log.wrapFunction("ListView.prototype.setLength")
// to add entry and exit trace messages to a function
Log.wrapFunction = function (targetName)
{
    var parts = targetName.split(".prototype.")
    var targetClassName = parts[0];
    var targetClass = eval(targetClassName);
    var targetFunctionName = parts[1];
    var targetFunction = targetClass.prototype[targetFunctionName];
    targetClass.prototype[targetFunctionName] = function () {
        var targetArgs = [];
        for(var i=0; i<arguments.length; i++)
          targetArgs.push(arguments[i]);
        log.info(targetName + "(" + targetArgs.toString() + ") entry");
        var entryTime = (new Date()).getTime();
        var r = targetFunction.apply(this, targetArgs);
        var timeSpent = (new Date()).getTime() - entryTime;
        log.info(targetName + "(" + targetArgs.toString() + ") exit ("+timeSpent+"ms)");
        targetClass.prototype[targetFunctionName].timeSpent += timeSpent;
        return r;
    };
    targetClass.prototype[targetFunctionName].timeSpent = 0;;
}
