// -*-c++-*-
// Based on code by Paul Sowden, from http://www.alistapart.com/stories/alternate/

function StyleSwitcher(selectElement) {
    this.select = selectElement;
    this.select.onchange = bindFunction(this.selectChanged, this);
    this.sheets = new Object();
    this.options = new Object();
    var links = document.getElementsByTagName("link");
    for(var i=0; i < links.length; i++) {
        var a = links[i];
        if(a.rel.indexOf("style") != -1 && a.title) {
            a.disabled = true;
            this.sheets[a.title] = a;
            var option = this.select.appendChild(document.createElement("option"));
            option.value = a.title;
            setElementTextContent(option, a.title);
            this.options[a.title] = option;

            if(a.rel.indexOf("alt") == -1) 
                this.preferredTitle = a.title;
        }
    }
    var cookie = readCookie(StyleSwitcher.cookieName);
    var title = (cookie && this.sheets[cookie]) ? cookie : this.preferredTitle;
    this.setActiveStyleSheet(title);
}

StyleSwitcher.cookieName = "webmpd-styleSheet";

StyleSwitcher.prototype.setActiveStyleSheet = function(title) {
  for(var i in this.sheets)
    this.sheets[i].disabled = (this.sheets[i].title != title);

  this.options[title].selected = true;

  createCookie(StyleSwitcher.cookieName, title, 7);
}

StyleSwitcher.prototype.selectChanged = function() {
    this.setActiveStyleSheet(this.select.value);
}
