function toNumber(x) { return x - 0; } // there are no words...

function min(a,b) {
    return a<b?a:b;
}
function max(a,b) {
    return a>b?a:b;
}

function isEmpty(o) {
    for(var a in o)
        return false;
    return true;
}

function shallowClone(o) {
    var c = {};
    for(var a in o)
        c[a] = o[a];
    return c;
}

function serialise(value, indent)
{
    // warning: no circular reference detection!

    if(!indent)
        indent = "";
    switch(typeof value)
    {
        case "object" :
            var s = indent + "{\n";
            for(var a in value)
            {
                s += serialise(a, indent + " ")
                     + ":\n"
                     + serialise(value[a], indent + " ")
                     + ",\n";
            }
            return s + indent + "}";
            break;
        case "number" :
            return value;
            break;
        case "string" :
            return '"' + value + '"';
            break;
        case "function" :
            return '<function>';
            break;
        default:
            return "unknown type";
    }
}

// bind a function to an object and arguments (inspired by MochiKit)
function bindFunction(targetFunction, self, preArguments) {
    var boundFunction = function () {
	var me = arguments.callee;
	var targetArguments = new Array();
	if(me.preArguments)
  	  for(var i=0; i<me.preArguments.length; i++)
  	    targetArguments.push(me.preArguments[i]);
	for(var a=0; a<arguments.length; a++)
  	  targetArguments.push(arguments[a]);

	return me.targetFunction.apply(me.self, targetArguments);
    }
    boundFunction.targetFunction = targetFunction;
    boundFunction.preArguments = preArguments;
    boundFunction.self = self;
    return boundFunction;
}

function inheritFrom(subClass, superClass) {
    // Notes: Members are copied rather than using the prototype
    // chain, to allow multiple inheritance. The _super pointers for
    // individual methods only work if inheritFrom() is called after
    // the prototype has been initialised.
    
    if(!subClass.prototype.inherited)
        subClass.prototype.inherited = {};

    subClass._super = superClass;

    for(var m in superClass.prototype)
        if(undefined === subClass.prototype[m])
            subClass.prototype[m] = superClass.prototype[m];
        else
            if("function" === typeof subClass.prototype[m])
                subClass.prototype[m]._super = superClass.prototype[m];
}

// From a functions arguments object, return the inherited (via
// inheritFrom) method that the function is overriding.
function getSuper(args)
{
    return args.callee._super;

    // I could get closer to a real java-like super() implementation
    // with something like arguments.callee.caller._super.apply(),
    // but konqueror lacks the caller property.
}

